<?php

/* $Id: document.php 5000 2011-07-19 11:56:04Z kx $ */

/**
 * «Облегченная» версия nc_search_document для загрузки результатов поиска
 */
class nc_search_result_document extends nc_search_data_persistent {
  protected $table_name = "Search_Document";

  protected $options = array(
      'id' => null,
      'contenttype' => 'text/html',
      'site_id' => null,
      'path' => null,             // только путь, без имени сайта — всегда ИСПОЛЬЗУЙТЕ url!
      'url' => null,
      'language' => null,
      'title' => null,
      'context' => null,
      'content' => null,
      'lastmodified' => null,
      'meta' => array(),
  );
  
  /**
   * Отображение в БД
   * @var array
   */
  protected $mapping = array(
      'id' => 'Document_ID',
      'site_id' => 'Catalogue_ID',
      'path' => 'Path',
      'title' => 'Title',
      'content' => 'Content',
      'contenttype' => 'ContentType',
      'language' => 'Language',
      'lastmodified' => 'LastModified',
      'meta' => 'Meta',
  );

  protected $serialized_options = array('meta');
  
  public function get($option) {
    $value = parent::get($option);
    // если у страницы нет заголовка — вернуть вместо него заглушку (иначе может
    // пропасть ссылка на документ в результатах поиска)
    if ($option == 'title' && !strlen(trim($value))) {
      // $value = nc_search_util::decode_path(parent::get('path'));
      $value = NETCAT_MODULE_SEARCH_NO_TITLE;
    }
    return $value;
  }

}
