<?php
/* $Id: function.inc.php 5402 2011-10-10 09:49:33Z gaika $ */
if ( !class_exists("nc_System") ) die("Unable to load file.");
/**
 * Init filed types, field name
 */
function InitVars () {
  global $nc_core, $field_types, $field_type_name, $type_of_edit, $type_of_edit_name, $type_of_error;

  $field_types = array(
    1 => 'i_type_string.gif',
    2 => 'i_type_int.gif',
    3 => 'i_type_text.gif',
    4 => 'i_type_classificator.gif',
    5 => 'i_type_bool.gif',
    6 => 'i_type_file.gif',
    7 => 'i_type_float.gif',
    8 => 'i_type_date.gif',
    9 => 'i_type_link.gif',
    10 => 'i_type_multiclassificator.gif'
  );

  $field_type_name = array(
    1 => CLASSIFICATOR_TYPEOFDATA_STRING,
    2 => CLASSIFICATOR_TYPEOFDATA_INTEGER,
    3 => CLASSIFICATOR_TYPEOFDATA_TEXTBOX,
    4 => CLASSIFICATOR_TYPEOFDATA_LIST,
    5 => CLASSIFICATOR_TYPEOFDATA_BOOLEAN,
    6 => CLASSIFICATOR_TYPEOFDATA_FILE,
    7 => CLASSIFICATOR_TYPEOFDATA_FLOAT,
    8 => CLASSIFICATOR_TYPEOFDATA_DATETIME,
    9 => CLASSIFICATOR_TYPEOFDATA_RELATION,
    10 => CLASSIFICATOR_TYPEOFDATA_MULTILIST
  );

  if ( $nc_core->modules->get_by_keyword('auth') && nc_auth_openid_possibility() ) {
    $field_types[11] = 'i_type_openid.gif';
    $field_type_name[11] = CLASSIFICATOR_TYPEOFDATA_OPENID;
  }

  $type_of_edit = array(
    1 => 'i_field_access_all.gif',
    2 => 'i_field_access_admin.gif',
    3 => 'i_field_access_no.gif'
  );

  $type_of_edit_name = array(
    1 => CLASSIFICATOR_TYPEOFEDIT_ALL,
    2 => CLASSIFICATOR_TYPEOFDATA_ADMINS,
    3 => CLASSIFICATOR_TYPEOFDATA_NOONE
  );

  $type_of_error = array(
    0=> CONTROL_FIELD_DB_ERROR,
    1 => CONTROL_FIELD_NAME_ERROR,
    2 => CONTROL_FIELD_ONE_RESERVED,
    3 => CONTROL_FIELD_EXITS_ERROR,
    4 => CONTROL_FIELD_FORMAT_ERROR,
    5 => CONTROL_FIELD_DIGIT_ERROR
  );

  return;
}


/**
 * Insert(modify, drop) into Table (Message or Subdivision or Template or.. see SystemTable) field
 * @param int FieldID
 * @param int type operation: 1 - add, 2 - modify, 3 - drop
 * @param object $db
 */
function ColumnInMessage ($FieldID, $type, $db) {
  global $db;

  $FieldID = intval($FieldID);

  $SelectField = $db->get_row("SELECT `Class_ID`, `Widget_Class_ID`, `Field_Name`, `TypeOfData_ID`, `NotNull`, `DoSearch`, `DefaultState`, `System_Table_ID` FROM `Field` WHERE `Field_ID`= '".$FieldID."'");

  if ( $SelectField->Widget_Class_ID ) return true;
  
  $isSys = $SelectField->System_Table_ID;  #for short, ==0 - if Component Field
  $TableName = $isSys ? GetSystemTableName($SelectField->System_Table_ID) : "Message".$SelectField->Class_ID;

  switch ($type) {
    case 1: $oper = "ADD";    break;
    case 2: $oper = "MODIFY"; break;
    case 3: $oper = "DROP";   break;
  }

  if ($type==2 && !$isSys ) {
    $arr_indexes = $db->get_results("SHOW INDEX FROM `Message{$SelectField->Class_ID}`", ARRAY_A);
    if (!empty($arr_indexes)) foreach($arr_indexes as $arr_indexes_row){
      if ($arr_indexes_row['Key_name'] == $SelectField->Field_Name) {
        $db->query("ALTER TABLE `Message".$SelectField->Class_ID."` DROP INDEX `".$SelectField->Field_Name."`");
      }
    }
  }


  

  $alter = "ALTER TABLE `".$TableName."` ".$oper." `".$SelectField->Field_Name."`";

  if ($type==3) {
    $db->query($alter);
    return true;
  }

  $alter.= " ";

  switch ($SelectField->TypeOfData_ID) {
    case 1:
      $alter.= "CHAR(255)"  ;
    break;
    case 2:
      $alter.= "INT";
    break;
    case 3:
      $alter.= "LONGTEXT";
    break;
    case 4:
      $alter.= "INT";
    break;
    case 5:
      $alter.= "TINYINT";
    break;
    case 6:
      $alter.= "CHAR(255)";
    break;
    case 7:
      $alter.= "DOUBLE";
    break;
    case 8:
      $alter.= "DATETIME";
    break;
    case 9:
      $alter.= "INT";
    break;
    case 10:
      $alter.= "TEXT";
    break;
    case 11:
      $alter.= "CHAR(255)";
    break;
  }

  switch  ( true ) {
    case $SelectField->DefaultState!=NULL && !in_array( $SelectField->TypeOfData_ID, array(3, 6, 8) ):
      $alter.= " NOT NULL DEFAULT '".$db->escape($SelectField->DefaultState)."'";
    break;
    case $SelectField->NotNull :
      $alter.= " NOT NULL";
    break;
    default:
      $alter.= " NULL";
  }

  $db->query($alter);
  if ( $isSys ) return true;

  if ($SelectField->DoSearch && $SelectField->TypeOfData_ID!=3) {
    $db->query("ALTER TABLE `".$TableName."` ADD INDEX (`".$SelectField->Field_Name."`)");
  }

  return true;
}



/**
 * Show field list
 *
 * @param int $Id - ClassID or SystemTableID
 * @param bool is field in system table
 * @param bool show for component wizard
 * @return bool  true - if success
 */
function FieldList ($Id, $isSys = 0, $isWizard = 0, $isWidget = 0) {

  global $db, $nc_core;
  global $UI_CONFIG, $ADMIN_PATH, $ADMIN_TEMPLATE;
  global $field_types, $field_type_name, $type_of_edit, $type_of_edit_name;

  $Id += 0;
  if (!$Id) return false;

  $where = $isSys ? "`System_Table_ID`" : ($isWidget ? "`Widget_Class_ID`" : "`Class_ID`");
  $where .= "='".$Id."'";

  $Result = $db->get_results("SELECT `Field_ID`, `Field_Name`, `Description`, `TypeOfData_ID`, `DoSearch`, `NotNull`, `TypeOfEdit_ID`, `Priority`
    FROM `Field`
    WHERE ".$where."
    ORDER BY `Priority`");

  if ( ($countFields=$db->num_rows) ) {

    if (!$isWizard) print "<form method='post' action='index.php'>\n";
    ?>
    <table border='0' cellpadding='0' cellspacing='0' width='100%'>
      <tr>
        <td bgcolor='#CCCCCC'>
          <table border='0' cellpadding='4' cellspacing='1' width='100%'>
            <tr>
              <td bgcolor='eeeeee'><font size='-2'><b>ID</td>
              <td bgcolor='eeeeee' width='20%'><font size='-2'><b><?=CONTROL_FIELD_LIST_NAME?></b></td>
              <td bgcolor='eeeeee' width='50%'><font size='-2'><b><?=CONTROL_FIELD_LIST_DESCRIPTION?></b></td>
              <td bgcolor='eeeeee' colspan='4' width='10%'><font size='-2'><b><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_DOPL?></b></font></td>
              <td bgcolor='eeeeee' align='center'>
                <img width='16' height='16' src=<?=$ADMIN_PATH?>images/prior.gif alt='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_PRIORITY?>'>
              </td>
              <? if (!$isWizard ): ?>
              <td bgcolor=eeeeee align=center>
                <img src='<?=$ADMIN_TEMPLATE?>img/i_delete.gif' width='16' height='16' alt='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWCATALOGUELIST_DELETE?>'></td>
              <? endif; ?>
            </tr>

    <?php

    foreach ( $Result as $Row ) {
      print "<tr>\n";
      print "  <td bgcolor='#FFFFFF'><font size='-2'><b>".$Row->Field_ID."</b></td>\n";
      if ($isWizard ) {
        print "  <td bgcolor='#FFFFFF'>".$Row->Field_Name."</td>\n";
      }
      else {
        print "  <td bgcolor='#FFFFFF'><a href='index.php?phase=4&amp;FieldID=".$Row->Field_ID."&amp;isSys=".$isSys."'>".$Row->Field_Name."</a></td>\n";
      }
      print "  <td bgcolor='#FFFFFF'><font size='-2'>".$Row->Description."</td>\n";
      print "  <td bgcolor='#FFFFFF'><img src='".$ADMIN_TEMPLATE."img/".$field_types[$Row->TypeOfData_ID]."' alt='".$field_type_name[$Row->TypeOfData_ID]."'></td>\n";
      print "  <td bgcolor='#FFFFFF'><img src='".$ADMIN_TEMPLATE."img/i_field_search_".($Row->DoSearch?"on":"off").".gif' alt='".CONTROL_FIELD_ONE_INDEX."'</td>\n";
      print "  <td bgcolor='#FFFFFF'><img src='".$ADMIN_TEMPLATE."img/i_field_notnull_".($Row->NotNull?"on":"off").".gif' alt='".CONTROL_FIELD_ONE_MUSTBE."'</td>\n";
      print "  <td bgcolor='#FFFFFF'><img src='".$ADMIN_TEMPLATE."img/".$type_of_edit[$Row->TypeOfEdit_ID]."' alt='".$type_of_edit_name[$Row->TypeOfEdit_ID]."'</td>\n";
      print "  <td align='center' bgcolor='#FFFFFF'>
                 <input type='text' name='priority[".$Row->Field_ID."]' value='".($Row->Priority?$Row->Priority:0)."'
                        size='3' class='s' maxlength='5' ".($isWizard ? "disabled":"").">
               </td>\n";
      if (!$isWizard)
       print "  <td align='center' bgcolor='#FFFFFF'><input type='checkbox' name='Delete[]' value='".$Row->Field_ID."'></td>\n";
      print "</tr>\n";
    }

    $name = $isSys ? "SystemTableID" : ($isWidget ? "widgetclass_id" : "ClassID");
    print "<input type='hidden' name='".$name."' value='".$Id."'>\n";
    print "<input type='hidden' name='isSys' value='".$isSys."'>\n";
    print  $nc_core->token->get_input();

    ?>
          </table>
        </td>
      </tr>
    </table>
    <br>
    <?php
  }
  else {
    nc_print_status(CONTROL_FIELD_LIST_NONE, 'info');
  }
  if( !$isWizard) {
    if ($countFields) {
      $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                          "caption" => CONTROL_FIELD_LIST_CHANGE,
                                          "action" => "mainView.submitIframeForm()" );
    }
    $location = $isSys ? "systemfield" : ($isWidget ? "widgetfield" : "field");
    $UI_CONFIG->actionButtons[] = array("id" => "addClass",
                                        "caption" => CONTROL_FIELD_LIST_ADD,
                                        "action" => "urlDispatcher.load('".$location.".add(".$Id.")')",
                                        "align" => "left");
    if ($countFields) {
     ?>
         <input type='hidden' name='phase' value='6'>
         <input type='submit' class='hidden'>
       </form>
    <?php
    }
  }
  return true;
} #   --- End function FieldList ---

#########################################
# Редактирование свойств отдельного поля ИЛИ СОЗДАНИЕ НОВОГО СВОЙСТВА
#########################################

/**
 * Show form to edit field or create new
 *
 * @param int Field id, 0 - if new
 * @param int ClassId or SystemTableId, if 0 - edit field
 * @param bool is field in system table
 * @param string action
 * @param string form name
 * @param string form id
 * @param string Advanced elements
 * @return bool true
 */
function FieldForm ($FieldID, $Id, $isSys=0, $action = "index.php", $FormName = '', $FormID = '', $Additional = '', $isWidget=0) {
  global $db, $nc_core;
  global $UI_CONFIG;
  global $field_type_name, $type_of_edit_name;

  $FieldID = intval($FieldID);
  $Id = intval($Id);

  if ($FieldID) {
    $Array = $db->get_row("SELECT `Field_Name`, `Description`, `TypeOfData_ID`, `Format`, `NotNull`, `Priority`, `DoSearch`,
      `Inheritance`, `DefaultState`, `TypeOfEdit_ID`, `Widget_Class_ID`
      FROM `Field`
      WHERE `Field_ID`='".$FieldID."' AND `Checked` = 1", ARRAY_A) ;
    if ($Array["Widget_Class_ID"]) {
        $isWidget = 1;
    }
  }
  else {
    $Array = $_POST;
    $where = $isSys ? "`System_Table_ID`" : ($isWidget ? "`Widget_Class_ID`" : "`Class_ID`");
    $where .= "='".$Id."'";

    if (!$Array["Priority"]) {
      $res = $db->get_var("SELECT (Priority+1) FROM `Field` WHERE ".$where." ORDER BY `Priority` DESC LIMIT 1");
      if (!is_null($res)) $Array["Priority"] = $res;
    }
  }
  // js для визульного заполнения "Формата"
  $js = "<script type='text/javascript' language='JavaScript'>
    ".( $Array["TypeOfData_ID"] ||  1 ? "nc_field_additional_format (".intval($Array["TypeOfData_ID"] ? $Array["TypeOfData_ID"] : 1).");" : "" )."

    function nc_field_additional_format ( selected_field ) {
     // select FS for file field
     document.getElementById('div_field_file').style.display = ((selected_field == 6) ? 'block' : 'none');

     //don't show Format field for text
     document.getElementById('div_format').style.display = ((selected_field == 3 || selected_field == 1 ) ? 'none' : 'block');

     //settings for text
     document.getElementById('div_field_text').style.display = ((selected_field == 3 ) ? 'block' : 'none');

    //settings for string
     document.getElementById('div_field_string').style.display = ((selected_field == 1 ) ? 'block' : 'none');

     //settings for date
     document.getElementById('div_field_date').style.display = ((selected_field == 8 ) ? 'block' : 'none');

    //settings for search
     document.getElementById('dosr').disabled = ((selected_field == 9 ) ? true : false);
     document.getElementById('dosr').style.background = ( (selected_field == 9) ? '#eee' : '' );

     // default value field
     var defaultField = document.getElementById('DefaultState');

     // default value field disabled
     defaultField.disabled = ( (selected_field==3 || selected_field==6 || selected_field==8 || selected_field==10) ? true : false );
     defaultField.style.background = ( (selected_field==3 || selected_field==6 || selected_field==8) ? '#eee' : '' );

     // default value field data
     defaultField.value = (selected_field==".intval($Array["TypeOfData_ID"])." ? '".$db->escape($Array["DefaultState"])."' : '');

     return false;
    }

    function nc_select_field () {
     var selected_field = document.getElementById('TypeOfData_ID').selectedIndex + 1 ;
     nc_field_additional_format (selected_field);
     nc_field_select_fs ();
     return false;
    }

    function nc_field_select_fs () {
      var selected_fs = document.getElementById('Format_FS').selectedIndex + 1;
      document.getElementById('attachment').disabled = ( selected_fs != 3 );
      document.getElementById('download').disabled = ( selected_fs != 3 );
      return false;
    }
    nc_field_select_fs ();
  </script>\n";

  print "<fieldset>";
  if ($FieldID) print "<legend><b>".($Array["Description"] ? $Array["Description"] : $Array["Field_Name"])."</b></legend>";

  print "<br/><form method='post' action='".$action."' name='".$FormName."' id='".$FormID."'><font color='gray'>";

  $Format_FS = NC_FS_PROTECTED; // тип по ФС по умолчанию
  $format_text = nc_field_parse_format("", NC_FIELDTYPE_TEXT); // для textarea значения по умолчанию

  if ($FieldID) {
    print CONTROL_FIELD_LIST_NAME.": <b>".$Array["Field_Name"]."</b><br><br>";

    switch ($Array['TypeOfData_ID']) {
      case NC_FIELDTYPE_FILE:  // определим тип ФС
        $format_file =nc_field_parse_format($Array['Format'], $Array['TypeOfData_ID']);
        $Format_FS =  $format_file['fs'];
        $file_attach = $format_file['disposition']; // закачиваемый или нет?
        $file_download = $format_file['download'];
        $Array['Format'] = nc_preg_replace('/(:?)(fs)(\d+)/', '', $Array['Format']); // уберем из Format тип ФС
        $Array['Format'] = nc_preg_replace('/(:?)(download)/', '', $Array['Format']); // уберем download
        $Array['Format'] = nc_preg_replace('/(:?)((attachment)|(inline))/', '', $Array['Format']); // уберем attachment
        break;
      case NC_FIELDTYPE_TEXT:
        $format_text = nc_field_parse_format($Array['Format'], $Array['TypeOfData_ID']);
        break;
      case NC_FIELDTYPE_DATETIME:
        $format_date = nc_field_parse_format($Array['Format'], $Array['TypeOfData_ID']);
        $Array['Format'] = $format_date['type'];
        break;
    }
  }
  else {
    print CONTROL_FIELD_LIST_NAMELAT.":<br><input type='text' name='FieldName' size='50' maxlength='64' value='".htmlspecialchars($Array["Field_Name"])."'><br><br>";
  }

  print CONTROL_FIELD_LIST_DESCRIPTION.":<br><input type='text' name='Description' size='50' maxlength='64' value='".htmlspecialchars($Array["Description"])."'><br><br>";

  $openid_possibility = ( $nc_core->modules->get_by_keyword('auth') && nc_auth_openid_possibility() );
  if ($FieldID && $Array['TypeOfData_ID']==11 && $openid_possibility) print "<input name='TypeOfData_ID' value='11' type='hidden'>";
  print CONTROL_FIELD_ONE_FTYPE.":<br><select name='TypeOfData_ID' id='TypeOfData_ID' onchange='nc_select_field(); return false;'".($FieldID && $Array['TypeOfData_ID']==11 && $openid_possibility ? " disabled='disabled'" : NULL).">";

  //print CONTROL_FIELD_ONE_FTYPE.":<br><select name='TypeOfData_ID' id='TypeOfData_ID' onchange='nc_select_field(); return false;'>";
  for ( $i = 1; $i <= count($field_type_name); $i++ ) {
    // Полe тиа "Связь с другими.." для системных полей не нужно
    if ( $isSys && ($i === 9) ) continue;

    if ($isWidget && ($i===4 || $i===5 || $i===6 || $i===8 || $i===9 || $i===10)) continue;
    print "<option ".($Array["TypeOfData_ID"]==$i?"selected":"")." value='".$i."'>".$i.": ".$field_type_name[$i]."</option>\n";
  }
  print "</select><br><br>";

  $html = "<div id='div_format'>".CONTROL_FIELD_ONE_FORMAT.":<br><input type='text' name='Format' size='50' maxlength='255' value='".($Array["TypeOfData_ID"] != 3 ? htmlspecialchars($Array["Format"], ENT_QUOTES) : "")."'><br><br></div>";

  $html .= "<div id='div_field_string'>".CONTROL_FIELD_ONE_FORMAT.":<br/>
    <select name='Format_String'>
      <option value='' >".CONTROL_FIELD_ONE_FORMAT_NONE."</email>
      <option value='email' ".($Array["Format"] == 'email' ? "selected='selected'" : "").">".CONTROL_FIELD_ONE_FORMAT_EMAIL."</option>
      <option value='url' ".($Array["Format"] == 'url' ? "selected='selected'" : "").">".CONTROL_FIELD_ONE_FORMAT_URL."</option>
      <option value='phone' ".($Array["Format"] == 'phone' ? "selected='selected'" : "").">".CONTROL_FIELD_ONE_FORMAT_PHONE."</option>
      <option value='tags' ".($Array["Format"] == 'tags' ? "selected='selected'" : "").">".CONTROL_FIELD_ONE_FORMAT_TAGS."</option>
    </select>
  </div>";
  // расширение формата для Файлов
  $html .= "<div id='div_field_file' style='display: none;'>\r\n
            ".CLASSIFICATOR_TYPEOFFILESYSTEM.":
            <select name='Format_FS' id='Format_FS' onchange='nc_field_select_fs(); return false;' >\r\n
               <option value='".NC_FS_SIMPLE."' ".( NC_FS_SIMPLE == $Format_FS ? 'selected' : '').">".CONTROL_FS_NAME_SIMPLE."</option>\r\n
               <option value='".NC_FS_ORIGINAL."' ".( NC_FS_ORIGINAL == $Format_FS ? 'selected' : '').">".CONTROL_FS_NAME_ORIGINAL."</option>\r\n
               <option value='".NC_FS_PROTECTED."' ".( NC_FS_PROTECTED == $Format_FS ? 'selected' : '').">".CONTROL_FS_NAME_PROTECTED."</option>\r\n
             </select>
             <br />
             <input type='checkbox' name='attachment' id='attachment' ".($file_attach ? "checked" : "")." disabled/>
               <label for='attachment'>".CONTROL_FIELD_ATTACHMENT."</label>
               <br/>
             <input type='checkbox' name='download' id='download' ".($file_download ? "checked" : "")." disabled/>
               <label for='download'>".CONTROL_FIELD_DOWNLOAD_COUNT."</label>
           </div><br/>";

  // расширение формата для текста
  $html .= "<div id='div_field_text' style='display: none;'>
  <table border='0' cellpadding='4' cellspacing='1' width='100%' bgcolor='#CCCCCC'>
  <col width='25%'/><col width='25%'/><col width='25%'/><col width='25%'/>
  <tr align='center'>
  <td bgcolor='#FFFFFF'><br/></td>
  <td bgcolor='#EEEEEE'><font size='-2'>".CONTROL_CONTENT_SUBDIVISION_FUNCS_ACCESS_INHERIT."</font></td>
  <td bgcolor='#EEEEEE'><font size='-2'>".CONTROL_CONTENT_SUBDIVISION_FUNCS_OBJ_YES."</font></td>
  <td bgcolor='#EEEEEE'><font size='-2'>".CONTROL_CONTENT_SUBDIVISION_FUNCS_OBJ_NO."</font></td>
  </tr>
  <tr align='center'>
  <td bgcolor='#EEEEEE'>".CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_HTML."</td>";
  // разрешать HTML-теги
  for ( $i = 0; $i <=2; $i++) {
    $html .= "<td bgcolor='".( $format_text['html'] == $i ? "#E7E7E7" : "#FFFFFF")."'>
      <input type='radio' class='w' name='format_html' value='".$i."' ".($format_text['html'] == $i ? "checked" :'').">
      </td>";
  }
  $html .= "</tr><tr align='center'>
  <td bgcolor='#EEEEEE'>".CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_BR."</td>";
  // перенос строки
  for ( $i = 0; $i <=2; $i++) {
    $html .= "<td bgcolor='".( $format_text['br'] == $i ? "#E7E7E7" : "#FFFFFF")."'>
      <input type='radio' class='w' name='format_br' value='".$i."' ".($format_text['br'] == $i ? "checked" :'').">
      </td>";
  }

  $html .= "
  </tr><tr align='center'>
  <td bgcolor='#EEEEEE'>".CONTROL_FIELD__EDITOR_EMBED_TO_FIELD."</td>";
  // встроить редактор
  for ( $i = 0; $i <=2; $i++) {
    $html .= "<td bgcolor='".( $format_text['fck'] == $i ? "#E7E7E7" : "#FFFFFF")."'>
      <input type='radio' class='w' name='format_fck' value='".$i."' ".($format_text['fck'] == $i ? "checked" :'').">
      </td>";
  }

  $html .= "</tr></table><br/>";


  $html .=CONTROL_FIELD__TEXTAREA_SIZE.":<br/>
  <table border='0' cellpadding='4' cellspacing='1' width='50%' bgcolor='#CCCCCC'>
  <col width='50%'/><col width='50%'/>
    <tr align='center'>
      <td bgcolor='#EEEEEE'>".CONTROL_FIELD_HEIGHT."</td>
      <td bgcolor='#FFFFFF'><input type='text' style='width:100%' name='format_height' value='".$format_text['rows']."'></td></tr>
    <tr align='center'>
      <td bgcolor='#EEEEEE'>".CONTROL_FIELD_WIDTH."</td>
      <td bgcolor='#FFFFFF'><input type='text' style='width:100%' name='format_width' value='".$format_text['cols']."'></td>
    </tr>
  </table>
  <br />

  <input type='checkbox' id='format_bbcode' name='format_bbcode' value='1' ".($format_text['bbcode']  ? "checked" :'')."  />
  <label for='format_bbcode'>".CONTROL_FIELD_BBCODE_ENABLED."</label>
  <br/>
  <input type='checkbox' id='format_usereditor' name='format_usereditor' value='1' ".($format_text['usereditor']  ? "checked" :'')."  />
  <label for='format_usereditor'>".CONTROL_FIELD_USER_EDITOR."</label>
  <br/><br/>
  </div>";

  $html .= "<div id='div_field_date' style='display: none'>
              <input type='checkbox' name='use_calendar' id='use_calendar' value='1' ".( $format_date['calendar'] ? "checked='checked'" : "")." />
              <label for='use_calendar'>".CONTROL_FIELD_USE_CALENDAR."</label>
            </div><br/>";

  echo $html;


  print "<input id='notn' type='checkbox' ".($Array["NotNull"]?"checked":"")." name='NotNull' value='1'> <label for='notn'>".CONTROL_FIELD_ONE_MUSTBE."</label><br>";
  if ( $isSys ) {
     print "<input id='inhr' type='checkbox' ".($Array["Inheritance"]?"checked":"")." name='Inheritance' value='1'>\n";
     print "<label for='inhr'>".CONTROL_FIELD_ONE_INHERITANCE."</label>\n<br><br>\n";
  }
  else {
    print "<input id='dosr' type='checkbox' ".($Array["DoSearch"] && $Array['TypeOfData_ID']!=9 ?"checked":"")." name='DoSearch' value='1' ".( $Array['TypeOfData_ID']!=9 ? "disabled='disabled'" : "").">\n";
    print "<label for='dosr'>".CONTROL_FIELD_ONE_INDEX."</label>\n<br><br>\n";
  }

  print CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_PRIORITY.": <input type='text' name='Priority' size='3' maxlength='5' value='".($Array["Priority"]+0)."'><br><br>";

  print CONTROL_FIELD_ONE_DEFAULT."*:<br>";
  print "<input type='text' name='DefaultState' id='DefaultState' size='50' maxlength='255' value='".htmlspecialchars($Array["DefaultState"])."'>\n";
  print "<br>* ".CONTROL_FIELD_ONE_DEFAULT_NOTE.".<br><br>\n";

  print "<table border='0' cellpadding='4' cellspacing='1' width='100%' bgcolor='#CCCCCC'>".
    "<col width='25%'/><col width='25%'/><col width='25%'/><col width='25%'/>".
    "<tr><td style='background:#FFF'></td>";

  if (!$Array["TypeOfEdit_ID"]) $Array["TypeOfEdit_ID"] = 1;

  for ($i = 1; $i <= count($type_of_edit_name); $i++)  {
    print "<td style='background:#EEE; text-align:center'><label for='mod".$i."'>".$type_of_edit_name[$i]."</label></td>";
  }

  print "</tr><tr><td style='background:#EEE; text-align:center'>".CONTROL_FIELD_ONE_ACCESS."</td>";

  for ($i = 1; $i <= count($type_of_edit_name); $i++)  {
    print "<td style='background:#FFF; text-align:center'><input type='radio' class='w' name='TypeOfEdit_ID' ";
    if ($Array["TypeOfEdit_ID"] == $i) print "checked ";
    print "value='".$i."' id='mod".$i."'></td>";
  }

  print "</tr>".
    "</table>";

  // js для визуальной настройки формата
  print $js;

  if (!$FieldID) {
    $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                        "caption" => CONTROL_FIELD_LIST_ADD,
                                        "action" => "mainView.submitIframeForm('".$FormID."')");
  } else {
    $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                        "caption" => CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE,
                                        "action" => "mainView.submitIframeForm('".$FormID."')");
  }

  $name = $isSys ? "SystemTableID" : ($isWidget ? "widgetclass_id" : "ClassID");

  if ($Id) {
    print "<input type='hidden' name='".$name."' value='".$Id."'>\n";
    print "<input type='hidden' name='phase' value='3'>\n";
  }
  else {
    if ($isSys) print "<input type='hidden' name='SystemTableID' value='".$Id."'>\n";
    print "<input type='hidden' name='FieldID' value='".$FieldID."'>\n";
    print "<input type='hidden' name='phase' value='5'>\n";
  }
  print $Additional;
  print $nc_core->token->get_input();
  print "<input type='hidden' name='isSys' value='".$isSys."'>\n";
  print "<input type='submit' class='hidden'>\n";
  print "</form>\n";

  print "</fieldset>";

  return true;
}

/**
 * Insert into DB properties of field
 *
 * @param bool is field in system table
 * @return int field id ,0 -  unknown error, -1 = incorrect field name, -2 = field name is mysql_keyword, -3 = field already exits
 *                                           -4 = incorrect field format
 *
 */
function FieldCompleted () {
  global $db;
  global $ClassID, $SystemTableID, $widgetclass_id;
  global $Inheritance, $DoSearch;
  global $FieldID, $FieldName, $Description, $TypeOfData_ID, $TypeOfEdit_ID, $Format, $Format_String, $Format_FS, $NotNull, $Priority, $DefaultState, $attachment, $download;
  global $format_height, $format_width, $format_html, $format_br, $format_fck, $format_bbcode,$format_usereditor, $use_calendar ;
  global $isSys, $widgetclass_id;
  
  $ClassID = intval($ClassID);
  $FieldID = intval($FieldID);

  if($TypeOfData_ID==1) $Format = $Format_String;
  if ( $FieldID ) {
    $TableName = $isSys ?  GetSystemTableName(GetSystemTableIDByFieldID($FieldID)) : "Message".GetClassIDByFieldID ($FieldID);
  }
  else {
    $TableName = $isSys ? GetSystemTableName($SystemTableID) : "Message".$ClassID;
  }

  // widgets
  $widgetclass_id += 0;
  if ( $FieldID ) {
    $widgetclass_id = $db->get_var("SELECT `Widget_Class_ID` FROM `Field` WHERE `Field_ID`= '".$FieldID."'");
  }

  $NotNull += 0;
  $DoSearch += 0;
  $Inheritance += 0;
  $Priority += 0;

  $format_height += 0;
  $format_width += 0;
  $format_html += 0;
  $format_br += 0;
  $format_fck += 0;
  $format_bbcode += 0;
  $format_usereditor += 0;

  $use_calendar += 0;

  // float field
  if ($TypeOfData_ID==7) $DefaultState = str_replace(",", ".", $DefaultState);

  $FieldName = str_replace(' ','', $FieldName);
  if ( !isCorrectFormat($Format, $TypeOfData_ID ) ) return -4;
  switch (1) {
    case ( count($db->get_results(($widgetclass_id ? "SELECT * FROM `Field` WHERE `Widget_Class_ID`='".$widgetclass_id."' AND `Field_Name`='".$FieldName."'" : "SHOW FIELDS FROM `".$TableName."` LIKE '".$FieldName."'"))) ):   //check for exits
      return -3;
    //case ( !$FieldName  || preg_match("/[^a-zA-Z0-9_]/", $FieldName) ):
    //  return -1;
    case ( nc_is_mysql_keyword($FieldName) ):                                                   // check for reserved sql words
      return -2;
  }

  // Добавим к Формату тип файловой системы\ настройки textarea
  if ( $TypeOfData_ID == NC_FIELDTYPE_FILE ) {
    if ( !$Format_FS ) $Format_FS = NC_FS_SIMPLE;
    $Format .= ":fs".$Format_FS;
    $Format .= ":".($attachment ? 'attachment' : 'inline');
    $Format .= ($download ? ':download' : '');

    if ( nc_substr($Format,0,1) == ':' ) $Format = nc_substr($Format, 1);
  }
  else if ($TypeOfData_ID == NC_FIELDTYPE_TEXT) {
    $Format = ($format_height ? $format_height : 5).":".($format_width ? $format_width : 60).";";
    $Format .= "html:".$format_html.";br:".$format_br.";fck:".$format_fck.";";
    $Format .= "bbcode:".$format_bbcode.";usereditor:".$format_usereditor.";";
  }
  else if ( $TypeOfData_ID == NC_FIELDTYPE_DATETIME && $use_calendar ) {
    $Format .= ($Format ?  ";" : "" ).'calendar';
  }
  // Add new field
  if ( !$FieldID ) {
    $fl1 = $isSys ? "`System_Table_ID`" : ($widgetclass_id ? "`Widget_Class_ID`" : "`Class_ID`");
    $fl2 = $isSys ? "`Inheritance`" : "`DoSearch`";
    $insert_field = "`Field` (".$fl1.", ".$fl2.", `Field_Name`,`Description`,`TypeOfData_ID`,`Format`,`NotNull`,`Priority`,`DefaultState`,`TypeOfEdit_ID`)";
    $value = " VALUES ('";
    $value .= $isSys ? $SystemTableID."','".$Inheritance : ($widgetclass_id ? $widgetclass_id."','".$DoSearch : $ClassID."','".$DoSearch);
    $value .= "','".$FieldName."','".$Description."',".$TypeOfData_ID.",'".$Format."',".$NotNull.",".$Priority.",'".$DefaultState."','".$TypeOfEdit_ID."')";
    $query = "INSERT INTO ".$insert_field.$value;
    if ( !$FieldName  || nc_preg_match("/^[\d]+/", $FieldName) ) return -5;
    if ( !$FieldName  || nc_preg_match("/[^a-zA-Z0-9_]/", $FieldName) ) return -1;
    // check if field name is already exists
    if ( !$widgetclass_id ) {
      $table = $ClassID ? "`Message".$ClassID."`" : $db->get_var("select `System_Table_Name` from `System_Table` where `System_Table_ID`=".$SystemTableID);
      if ($db->column_exists($table, $FieldName)) { return -3; }
    }
    if ($db->query($query) ) {
      $CurrentFieldID = $db->insert_id; 
      if (!$widgetclass_id) ColumnInMessage($CurrentFieldID, 1, $db);
    }
    return $CurrentFieldID;
  }
  // Update field
  else {
    $query = "UPDATE `Field` SET `Description`='".$Description."',`TypeOfData_ID`='".$TypeOfData_ID."',`Format`='".$Format."',`NotNull`='".$NotNull;
    $query .= "',`Priority`='".$Priority."',`DefaultState`='".$DefaultState."',`TypeOfEdit_ID`='".$TypeOfEdit_ID."'";
    $query .= $isSys ? ", `Inheritance`='".$Inheritance."'" : ", `DoSearch`='".$DoSearch."'";
    $query .= " WHERE `Field_ID`='".$FieldID."'";
    if ($db->query($query) && !$widgetclass_id) ColumnInMessage ($FieldID, 2, $db);

    return $FieldID;
  }

  return 0;
}


/**
 * Update priority
 *
 * @param array priority
 * @return bool
 */
function UpdateFieldPriority($priority) {
  global $db;

  if ( is_array($priority) && !empty($priority) ) {
    foreach($priority AS $key => $val) {
      $db->query("UPDATE `Field` SET `Priority` = '".(int)$val."' WHERE `Field_ID` = '".(int)$key."'");
    }
  }

  return true;
}

/**
 * Confirm to field delete
 *
 * @param array fields
 * @param int Id - ClassId or SystemTableID
 * @param bool is field in system table
 * @return empty
 */
function ConfirmFieldsRemoval($fields, $Id, $isSys = 0, $widgetclass_id='') {

  global $db, $UI_CONFIG;
  global $priority;

  $nc_core = nc_Core::get_object();
  $fields = array_map('intval', $fields);
  $field_array = $db->get_results("SELECT `Field_ID`, `Field_Name`, `Description`, `TypeOfData_ID` FROM `Field` WHERE Field_ID IN (".join(',', $fields).")", ARRAY_A);

  if ($db->num_rows > 1) {
    nc_print_status(CONTROL_FIELD_MSG_CONFIRM_REMOVAL_MANY, 'info');
  } else {
    nc_print_status(CONTROL_FIELD_MSG_CONFIRM_REMOVAL_ONE, 'info');
  }

  $name = $isSys ? "SystemTableID" : "ClassID";

  print "<form method='post' action='index.php'>\n";
  print "<input type='hidden' name='phase' value='7'>\n";
  print "<input type='hidden' name='widgetclass_id' value='".$widgetclass_id."'>\n";
  print "<input type='hidden' name='".$name."' value='".$Id."'>\n";
  print "<input type='hidden' name='isSys' value='".$isSys."'>\n";
  print $nc_core->token->get_input();

  print "<ul>\n";
  foreach ((array)$field_array as $field) {
    print "  <li>".$field['Field_Name']." (".$field['Description'].")<input type='hidden' name='Delete[]' value='".$field['Field_ID']."'>";
  }
  print "</ul>\n";

  if ($priority) foreach ($priority as $key => $val) echo "<input type='hidden' name='priority[".$key."]' value='".$val."'>\n";
  print "</form>\n";

  $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                      "caption" => CONTROL_FIELD_CONFIRM_REMOVAL,
                                      "action" => "mainView.submitIframeForm()");
  return;
}

/**
 * Delete fields
 *
 * @param array $fields
 * @return int count deleted fields
 */
function DeleteFields($fields) {
  global $db, $UI_CONFIG;
  // start up value
  $fields_to_delete = array();
  // if no array
  if ( empty($fields) ) return 0;
  //
  $fields = array_map('intval', $fields);
  $fields_data = $db->get_results("SELECT `Field_ID`, `System_Table_ID` FROM `Field`
    WHERE `Field_ID` IN (".join(", ", $fields).")", ARRAY_A);
  // walk
  foreach ($fields_data as $field) {
    if ( ColumnInMessage($field['Field_ID'], 3, $db) ) {
      $fields_to_delete[] = intval($field['Field_ID']);
      $UI_CONFIG->treeChanges['deleteNode'][] = ($field['System_Table_ID'] ? "system" : "")."field-".$field['Field_ID'];
    }
  }
  // delete fields from base
  if ( !empty($fields_to_delete) ) {
    // delete fields files
    DeleteFieldsFiles($fields_to_delete);
    // delete fields from base
    $db->query("DELETE FROM `Field` WHERE `Field_ID` IN (".join(", ", $fields_to_delete).")");
    return $db->rows_affected;
  }
  // return 0 if no fields deleted from base
  return 0;
}

function DeleteFieldsFiles ($fields) {
  global $db, $FILES_FOLDER;
  // set as array
  $fields = (array)$fields;
  $file_fields_to_delete = array();
  // validate for security reason
  $fields = array_map("intval", $fields);
  // return if array is empty
  if ( empty($fields) ) return 0;
  // get files info to delete
  $files_to_delete = $db->get_results("SELECT ft.`Field_ID`, ft.`Virt_Name`, ft.`File_Path`, fl.`System_Table_ID` FROM `Filetable` AS ft
    LEFT JOIN `Field` as fl ON ft.`Field_ID` = fl.`Field_ID`
    WHERE ft.`Field_ID` IN (".join(", ", $fields).") AND fl.`TypeOfData_ID` = 6", ARRAY_A);

  if ( empty($files_to_delete) ) return 0;

  foreach ($files_to_delete AS $_file_to_delete) {
    // set full path to file
    $file_to_delete_path = $FILES_FOLDER.$_file_to_delete['File_Path'].$_file_to_delete['Virt_Name'];
    // try to delete file from disk
    if ( is_writable($file_to_delete_path) ) {
      @unlink($file_to_delete_path);
      $file_fields_to_delete[] = $_file_to_delete['Field_ID'];
    }
  }
  // drop rows form `Filetable` table
  if ( !empty($file_fields_to_delete) ) {
    $db->query("DELETE FROM `Filetable` WHERE `Field_ID` IN (".join(", ", $file_fields_to_delete).")");
    return $db->rows_affected;
  }
  // return 0 if no files deleted from base
  return 0;
}

/** Checking - correct field format
 *@param Format
 *@param Date type
 *@return bool, true - if correct
*/
function isCorrectFormat ($format, $id ) {
  switch ( $id ) {
    case NC_FIELDTYPE_SELECT: // select
      return (bool)$format; // формат не должен быть пустой
      break;
    case NC_FIELDTYPE_MULTISELECT: //MultuSelect
      return nc_preg_match("/^[_a-z0-9]+((:)((select(:[0-9]+)?)|(checkbox)))?$/i", $format);
      break;
    case NC_FIELDTYPE_RELATION: // связь с объектами
      return (bool)$format; // формат не должен быть пустой
      break;
    default: //Для остальных типов данных проверки нет
      return true;
  }
}
###############################################################################



/**
 * Check, is param is mysql keyword
 *
 * @param string Field Name
 * @return bool true - if keyword
 */
function nc_is_mysql_keyword ($FieldName) {
   return in_array(strtolower($FieldName), nc_preg_split("/\s+/",
                 "accessible add all alter analyze and as asc asensitive
                  before between bigint binary blob both by call cascade
                  case change char character check collate column condition connection
                  constraint continue convert create cross current_date
                  current_time current_timestamp current_user
                  cursor database databases day_hour day_microsecond day_minute
                  day_second dec decimal declare default delayed delete desc describe
                  deterministic distinct distinctrow div double drop dual each else
                  elseif enclosed escaped exists exit explain false fetch float
                  float4 float8 for force foreign from fulltext goto grant
                  group having high_priority hour_microsecond hour_minute hour_second
                  if ignore in index infile inner inout insensitive insert
                  int int1 int2 int3 int4 int8 integer interval into is iterate join
                  key keys kill label leading leave left like limit linear lines load
                  localtime localtimestamp lock long longblob longtext
                  loop low_priority match mediumblob mediumint mediumtext
                  middleint minute_microsecond minute_second mod modifies natural
                  not no_write_to_binlog null numeric on optimize
                  option optionally or order out outer outfile precision primary
                  procedure purge range read reads read_only read_write real references
                  regexp release rename repeat replace require restrict return revoke
                  right rlike schema schemas second_microsecond select sensitive separator set
                  show smallint spatial specific sql sqlexception sqlstate sqlwarning sql_big_result
                  sql_calc_found_rows sql_small_result ssl starting straight_join table
                  terminated then tinyblob tinyint tinytext title to trailing trigger true
                  undo union unique unlock unsigned update upgrade usage use
                  using utc_date utc_time utc_timestamp values varbinary
                  varchar varcharacter varying when where while with write x509
                  xor year_month zerofill _nc_final UserGroup"));
}


class ui_config_field extends ui_config {

  private $_location;

  function ui_config_field($active_tab = 'edit', $field_id, $id, $is_sys) {

    global $db;
    $id = intval($id);
    $field_id = intval($field_id);
    
    $this->_location = $is_sys ? "systemfield" : "field";
    $this->headerImage = 'i_folder_big.gif';

    switch ($active_tab) {
      case 'add':
        $this->tabs = array(
                        array('id' => 'add',
                              'caption' => CONTROL_FIELD_ADDING,
                              'location' => $this->_location.".add(".$id.")")
                      );
        $this->headerText = $is_sys ? constant($db->get_var("SELECT `System_Table_Rus_Name` FROM `System_Table` WHERE `System_Table_ID` = '".$id."'")) :
                                      $db->get_var("SELECT `Class_Name` FROM `Class` WHERE `Class_ID` = '".$id."'");

        break;
      case 'edit':
        $this->tabs = array(
                        array('id' => 'edit',
                              'caption' => CONTROL_FIELD_EDITING,
                              'location' => $this->_location.".edit(".$field_id.")")
                      );
        $this->headerText = $db->get_var("SELECT `Description` FROM `Field` WHERE `Field_ID` = '".$field_id."'");
        $this->treeSelectedNode = $this->_location."field-{$field_id}";
        break;
      case 'delete':
        $this->tabs = array(
                     array('id' => 'delete',
                             'caption' => CONTROL_FIELD_DELETING,
                             'location' => $this->_location.".delete(".$id.")")
              );
       $this->headerText = $is_sys ? constant($db->get_var("SELECT `System_Table_Rus_Name` FROM `System_Table` WHERE `System_Table_ID` = '".$id."'")) :
                                     $db->get_var("SELECT `Class_Name` FROM `Class` WHERE `Class_ID` = '".$id."'");
       $this->treeSelectedNode = $is_sys ? "systemclass-{".$system_class_id."}" : "dataclass-{".$class_id."}";

       break;
    }

    $this->activeTab = $active_tab;
    $this->treeMode = 'developer';
  }

  function updateTreeFieldNode($field_id, $field_type) {
    global $field_types;

    $this->treeChanges['updateNode'][] = array("nodeId" => $this->_location."-".$field_id,
                                               "image" => $field_types[$field_type]);
    return;
  }

} #end class ui_config_field




?>
