<?php
/* $Id: quickbar.inc.php 5281 2011-09-02 14:53:41Z andrey $ */

function nc_quickbar_in_template_header ($buffer) {
  global $nc_core;
  global $MODULE_VARS, $AUTH_USER_ID, $ADMIN_TEMPLATE, $HTTP_ROOT_PATH, $ADMIN_PATH;
  global $SUB_FOLDER, $REQUEST_URI, $REQUEST_METHOD, $ADMIN_AUTHTIME;
  global $current_catalogue, $current_sub, $current_cc, $current_user, $AUTHORIZE_BY;
  global $inside_admin, $admin_mode, $user_table_mode, $action, $message;
  
  // do not show from admin panel and if permission not granted
  if ( $inside_admin || !nc_quickbar_permission() ) return $buffer;
  
  // user profile url
  if ( $nc_core->modules->get_by_keyword('auth') ) {
    $profile_url = nc_auth_profile_url($AUTH_USER_ID);
  } 

  // view link
  $view_link = ($current_sub['Hidden_URL']!="/index/" ? $current_sub['Hidden_URL'] : "/").($message && $current_cc['EnglishName'] ? $current_cc['EnglishName']."_".$message.".html" : "");
  // edit link
  if (!$user_table_mode) {
    $edit_link = $HTTP_ROOT_PATH.($action=="full" || $action=="change" ? "message" : $action).".php?catalogue=".$current_catalogue['Catalogue_ID'].($current_sub['Subdivision_ID'] ? "&amp;sub=".$current_sub['Subdivision_ID'] : "").($current_cc['Sub_Class_ID'] ? "&amp;cc=".$current_cc['Sub_Class_ID'] : "").($message ? "&amp;message=".$message : "");
  }
  else {
    $edit_link = $HTTP_ROOT_PATH."?catalogue=".$current_catalogue['Catalogue_ID'].($current_sub['Subdivision_ID'] ? "&amp;sub=".$current_sub['Subdivision_ID'] : "").($current_cc['Sub_Class_ID'] ? "&amp;cc=".$current_cc['Sub_Class_ID'] : "").($message ? "&amp;message=".$message : "");
  }
  
  // admin link
  $admin_link = "";
  switch (true) {
    case $current_cc['Class_ID'] && $message:
      $admin_link = "#object.edit(".$current_cc['Class_ID'].",".$message.")";
    break;
    case $current_cc['Sub_Class_ID']:
      $admin_link = "#object.list(".$current_cc['Sub_Class_ID'].")";
    break;
    case $current_sub['Subdivision_ID']:
      $admin_link = "#subclass.list(".$current_sub['Subdivision_ID'].")";
    break;
    case $current_catalogue['Catalogue_ID']:
      $admin_link = "#site.map(".$current_catalogue['Catalogue_ID'].")";    
  }
  // append main admin path
  $admin_link = $ADMIN_PATH.$admin_link;
  
  // cache link
  if ( $nc_core->modules->get_by_keyword('cache') ) $cache_link = $ADMIN_PATH."#module.cache";
  
  // quickbar code
  $addon = "<!-- Netcat QuickBar -->\n".
    "<script type='text/javascript' src='".$ADMIN_PATH."js/classes/nc_cookies.class.js'></script>\n".
    "<script type='text/javascript' src='".$ADMIN_PATH."js/classes/nc_drag.class.js'></script>\n".
    "<script type='text/javascript' src='".$ADMIN_PATH."js/classes/nc_quickbar.class.js'></script>\n".
    
    "<div id='netcatQuickBar' style=\\\"font-family:Tahoma,Arial,Verdana !important; font-size:8pt !important; z-index:999 !important; border:1px solid #CCC !important; border-left:none !important; height:44px !important; margin:0 !important; padding:0 !important; position:fixed !important; _position:absolute; top:0; _top:expression(Math.round(nc_cookies.get('QUICK_BAR_POSY')) + Math.round(offsetParent.scrollTop) + 'px'); left:0; background:#F3F3F3 !important;\\\">\n".
    
    "<table cellpadding='0' cellspacing='0' style='border:none !important'>\n".
    "<tr>\n".
    
    "<td style='vertical-align:middle !important; border:none !important; padding: 0px !important; white-space: nowrap;' >\n".
    "<div id='quickBarAddonSection' style='border:none !important; padding:0 !important; margin:0 !important'>\n".
      "<table cellpadding='0' cellspacing='0' style='height:100% !important; border:none !important'>\n".
      "<tr>\n".
      "<td style='padding: 0px !important; border:none !important;white-space: nowrap;' >\n".
        "<div id='quickBarSlider' onmouseup='quickBar.SavePos()' style='width:7px !important; border:none !important; cursor:move !important; height:44px !important; background:url(".$ADMIN_TEMPLATE."img/slider_left.gif) !important' title='".NETCAT_QUICKBAR_SLIDER_TOOLTIP."'></div>\n".
      "</td>\n".
      "<td style='vertical-align:middle !important; padding: 0px !important; border:none !important ;white-space: nowrap'  >\n".
        "<img src='".$ADMIN_TEMPLATE."img/i_netcat_big.gif' id='quickBarLogo' onclick='quickBar.Hide();' alt='".NETCAT_QUICKBAR_LOGO_TOOLTIP."' title='".NETCAT_QUICKBAR_LOGO_TOOLTIP."' style='margin:5px 7px 0 7px !important; width:32px !important; height:32px !important; border:none !important'/>\n".
      "</td>\n".
      "</tr>\n".
      "</table>\n".
    "</div>\n".
    "</td>\n".
    
    "<td style='border:none !important; padding: 0px !important;white-space: nowrap' >\n".
    "<div id='quickBarMainSection' style='border:none !important; padding:0 !important; margin:0 !important'>\n".
    
    "<table cellpadding='0' cellspacing='0' style='height:100% !important; border:none !important; font-size:8pt !important'>\n".
    "<tr>\n".
      "<td style='padding: 0px !important; width:2px !important; border:none !important; height:38px !important; background:url(".$ADMIN_TEMPLATE."img/quickbar_separator.gif) no-repeat !important;white-space: nowrap'></td>\n".
      "<td style='padding: 0px !important; vertical-align:middle !important; border:none !important; padding:0 10px !important; height:38px !important; text-align:center !important; white-space: nowrap'>\n".
        "<a href='".($SUB_FOLDER ? $SUB_FOLDER."/" : "/").($admin_mode ? ltrim($HTTP_ROOT_PATH, "/") : "")."' style='border:none !important; text-decoration:none !important'><img src='".$ADMIN_TEMPLATE."img/i_home.gif' alt='".NETCAT_QUICKBAR_BUTTON_MAINPAGE."' title='".NETCAT_QUICKBAR_BUTTON_MAINPAGE."' style='width:16px !important; height:16px !important; border:none !important'/></a>\n".
      "</td>\n".
      "<td style='padding: 0px 10px 0px 0px !important; vertical-align:middle !important; border:none !important; height:38px !important; text-align:center !important; white-space: nowrap'>\n".
        "<a href='".$SUB_FOLDER.$view_link."' style='border:none !important; text-decoration:none !important'><img src='".$ADMIN_TEMPLATE."img/i_preview.gif' alt='".NETCAT_QUICKBAR_BUTTON_VIEWMODE."' title='".NETCAT_QUICKBAR_BUTTON_VIEWMODE."' style='width:16px !important; height:16px !important; border:none !important'/></a>\n".
      "</td>\n".
      "<td style='padding: 0px 10px 0px 0px;!important; vertical-align:middle !important; border:none !important;text-align:center !important; white-space: nowrap'>\n".
        "<a href='".$SUB_FOLDER.$edit_link."' style='border:none !important; text-decoration:none !important'><img src='".$ADMIN_TEMPLATE."img/i_obj_edit.gif' alt='".NETCAT_QUICKBAR_BUTTON_EDITMODE."' title='".NETCAT_QUICKBAR_BUTTON_EDITMODE."' style='width:16px !important; height:16px !important; border:none !important'/></a>\n".
      "</td>\n".
      ( $nc_core->modules->get_by_keyword('auth') && $current_user['InsideAdminAccess'] /* Проверка на доступ в админку*/
         || !$nc_core->modules->get_by_keyword('auth') && $nc_core->db->get_var("SELECT `InsideAdminAccess` FROM `User` WHERE `User_ID`='".intval($AUTH_USER_ID)."'") ?
      "<td style='padding: 0px 10px 0px 0px !important; vertical-align:middle !important; border:none !important; text-align:center !important; white-space: nowrap'>\n".
        "<a href='".$admin_link."' style='border:none !important; text-decoration:none !important'><img src='".$ADMIN_TEMPLATE."img/i_developer.gif' alt='".NETCAT_QUICKBAR_BUTTON_ADMIN."' title='".NETCAT_QUICKBAR_BUTTON_ADMIN."' style='width:16px !important; height:16px !important; border:none !important'/></a>\n".
      "</td>\n" : "").
      ( $nc_core->modules->get_by_keyword('cache') && $current_cc['Cache_Access_ID'] ? 
      "<td  style='padding: 0px 10px 0px 0px !important; vertical-align:middle !important; border:none !important;  text-align:center !important; white-space: nowrap'>\n".
        "<a href='".$cache_link."' style='border:none !important; text-decoration:none !important'><img src='".$ADMIN_TEMPLATE."img/i_".($current_cc['Cache_Access_ID']==2 ? "delete" : "module_cache").".gif' alt='".($current_cc['Cache_Access_ID']==2 ? NETCAT_QUICKBAR_CACHED_OFF : NETCAT_QUICKBAR_CACHED_ON)."' title='".($current_cc['Cache_Access_ID']==2 ? NETCAT_QUICKBAR_CACHED_OFF : NETCAT_QUICKBAR_CACHED_ON)."' style='width:16px !important; height:16px !important; border:none !important'/></a>\n".
      "</td>\n" : "");
      
      if ( ($favorites = nc_quickbar_favorites()) ) {
        $addon.= "<td style='vertical-align:middle !important; border:none !important; padding:0 10px 0 12px !important; text-align:center !important; background:url(".$ADMIN_TEMPLATE."img/quickbar_separator.gif) no-repeat left !important; white-space: nowrap'>\n".
        $favorites.
        "</td>\n";
      }
      
      $addon.= "<td style='vertical-align:middle !important; border:none !important; font-size:8pt !important; color:#333 !important; text-align:right !important; padding:0 10px 0 12px !important; background:url(".$ADMIN_TEMPLATE."img/quickbar_separator.gif) no-repeat left !important; white-space: nowrap'>\n".
      ($AUTH_USER_ID
        ? NETCAT_QUICKBAR_GREETING.", <b>".(!$admin_mode && $profile_url ? "<a href='".$profile_url."' style='color:#333 !important'>".$current_user[$AUTHORIZE_BY]."</a>" : $current_user[$AUTHORIZE_BY])."</b><br/>\n".
        "<a href='".($MODULE_VARS['auth']
          ? $SUB_FOLDER.$HTTP_ROOT_PATH."modules/auth/?logoff=1&amp;REQUESTED_FROM=".$REQUEST_URI."&amp;REQUESTED_BY=".$REQUEST_METHOD
          : $ADMIN_PATH."unauth.php")."' style='border:none !important; text-decoration:none !important; color:#333 !important'><b>".NETCAT_QUICKBAR_LOGOUT."</b></a>\n"
        : "&nbsp;"
      ).
      "</td>\n".
    "</tr>\n".
    "<tr>\n".
      "<td colspan='9' style='padding: 0px !important; border:none !important; background:url(".$ADMIN_TEMPLATE."img/quickbar_rule.gif) repeat-x left bottom !important; height:6px !important;' onmouseover='quickBar.RuleValue(this, event)'></td>\n".
    "</tr>\n".
    "</table>\n".
    
    "</div>\n".
    "</td>\n".
    "</tr>\n".
    "</table>\n".
    
    "</div>\n".
  // this code make smooth fixed element scrolling in IE
  "<!--[if lte IE 6]>\n<script type='text/javascript'>if (document.body.filters) true;</script>\n<![endif]-->\n".
  "<script type='text/javascript'>\n".
    "var quickBar = new nc_quickbar({'ADMIN_AUTHTIME':'".$ADMIN_AUTHTIME."', 'ADMIN_TEMPLATE':'".$ADMIN_TEMPLATE."'});\n".
    "quickBar.Restore();\n".
  "</script>\n".
  "<!-- /Netcat QuickBar -->\n";

  // pattern and replacement for preg_replace()
  switch (true) {
    case nc_preg_match("/\<\s*?frameset.*?\>/im", $buffer):
      // don't show QuickBar
    break;
    case nc_preg_match("/\<\s*?body.*?\>/im", $buffer):
      $preg_pattern = "/(\<\s*?body.*?\>){1}/im";
      $preg_replacement = "\$1\n".$addon;
    break;
    case nc_preg_match("/\<\s*?html\s*?\>/im", $buffer):
      $preg_pattern = "/(\<\s*?html\s*?\>){1}/im";
      $preg_replacement = "\$1\n<body>".$addon."</body>";
    break;
    //default:
      //$preg_pattern = "/(\A)/im";
      //$preg_replacement = $addon."\n\$1";
  }
  
  if ($preg_pattern && $preg_replacement) {
    // this string need for IE 6 position fixed DOCTYPE hack
    //$buffer = "<!-- Netcat QuickBar for IE DOCTYPE undo -->\n".$buffer;
    // append panel in buffer
    $buffer = nc_preg_replace($preg_pattern, $preg_replacement, $buffer);
  }
    
  return $buffer;
}

function nc_quickbar_favorites () {
  global $db, $admin_mode, $action;
  global $HTTP_ROOT_PATH, $REQUEST_URI, $SUB_FOLDER;
  global $current_sub, $user_table_mode;
  
  $favorites = nc_quickbar_get_favorites();

  if ( !empty($favorites) ) {
    //Favorites
    $result = "<select id='quickBarFavorites' name='quickBarFavorites' onchange='window.location.href = this.value;'>\n";
    $result.= "<option value='#' selected='selected'>".NETCAT_QUICKBAR_FAVORITES_HEADER."</option>\n";
    // options
    foreach ($favorites as $favorite) {
      // Sub_Class_ID
      $subclass_id = $db->get_var("SELECT `Sub_Class_ID` FROM `Sub_Class` WHERE `Subdivision_ID` = '".$favorite['Subdivision_ID']."' ORDER BY `Priority`");
      // location link
      if ($admin_mode) {
        $fav_link = $HTTP_ROOT_PATH."?catalogue=".$favorite['Catalogue_ID'].($favorite['Subdivision_ID'] ? "&sub=".$favorite['Subdivision_ID'] : "").($subclass_id ? "&cc=".$subclass_id : "");
      }
      else {
        $fav_link = $SUB_FOLDER . $favorite['Hidden_URL'];
      }
      // if on this page
      $disabled = $current_sub['Subdivision_ID']==$favorite['Subdivision_ID'] ? " disabled" : "";
      // select line
      $result.= "<option value='".$fav_link."'".$disabled.">".$favorite['Subdivision_Name']."</option>\n";
    }
    $result.= "</select>\n";
  }
  else {
    //$result = NETCAT_QUICKBAR_FAVORITES_EMPTY."\n";
    $result = "";
  }
  
  return $result;
}


function nc_quickbar_permission () {
  global $perm;

  if ( !is_object($perm) ) Authorize(); 
 
  if ( !is_object($perm) ) return false;
  
  return $perm->isAnySubClassAdmin();

}


function nc_quickbar_get_favorites () {
  global $db, $perm, $catalogue;

  if ( !is_object($perm) ) return false;
  

  $select = "sub.Subdivision_ID, sub.Subdivision_Name, sub.Catalogue_ID, sub.ExternalURL, sub.Hidden_URL, sub.Checked AS SubChecked,
             catalogue.Domain, catalogue.Catalogue_Name, catalogue.Checked AS CatalogueChecked";
  

  $allow_id = $perm->GetAllowSub($catalogue, MASK_ADMIN | MASK_MODERATE, false, true, false);
  
  $favorites = $db->get_results("SELECT ".$select."
    FROM Subdivision AS sub
    LEFT JOIN Catalogue AS catalogue ON catalogue.Catalogue_ID = sub.Catalogue_ID
    WHERE sub.Favorite = '1' 
    AND ".(is_array($allow_id) ? "Subdivision_ID IN (".join(',', (array)$allow_id).")" : "1")."
    ORDER BY Catalogue_ID,
    Subdivision_ID", ARRAY_A);


  return $favorites;
}

?>