CREATE TABLE `Search_Extension` ( `Rule_ID` int(11) NOT NULL auto_increment, 	`ExtensionInterface` varchar(255) NOT NULL, 	`ExtensionClass` varchar(255) NOT NULL, 	`SearchProvider` varchar(255) default NULL, 	`Action` varchar(255) default NULL, 	`Language` varchar(255) default NULL, 	`ContentType` varchar(255) default NULL, 	`Priority` tinyint(5) unsigned NOT NULL DEFAULT 127, 	`Checked` tinyint(1) NOT NULL DEFAULT 1, 	PRIMARY KEY	 (`Rule_ID`) ) ENGINE=MyISAM	 DEFAULT CHARSET=utf8;
INSERT INTO `Search_Extension` (`Rule_ID`, `ExtensionInterface`, `ExtensionClass`, `SearchProvider`, `Action`, `Language`, `ContentType`, `Priority`) VALUES (1, 'nc_search_provider', 'nc_search_provider_zend', '', 'indexing', '', '', 127), (2, 'nc_search_document_parser', 'nc_search_document_parser_html', '', '', '', 'text/html', 127), (3, 'nc_search_language_analyzer', 'nc_search_language_analyzer_morphy', '', '', 'ru', '', 127), (4, 'nc_search_language_analyzer', 'nc_search_language_analyzer_morphy', '', '', 'en', '', 127), (5, 'nc_search_language_filter', 'nc_search_language_filter_normalize', '', '', '', '', 20), (6, 'nc_search_language_filter', 'nc_search_language_filter_minlength', '', '', '', '', 40), (7, 'nc_search_language_filter', 'nc_search_language_filter_case', '', '', '', '', 60), (8, 'nc_search_language_filter', 'nc_search_language_filter_yo', '', '', 'ru', '', 80), (9, 'nc_search_language_filter', 'nc_search_language_filter_stopwords', '', '', '', '', 120), (10, 'nc_search_language_filter', 'nc_search_language_filter_synonyms', '', '', '', '', 140), (11, 'nc_search_language_filter', 'nc_search_language_filter_analyzer', '', '', '', '', 100), (12, 'nc_search_language_corrector', 'nc_search_language_corrector_quotes', '', '', '', '', 50), (13, 'nc_search_language_corrector', 'nc_search_language_corrector_basic', '', '', '', '', 100);
CREATE TABLE `Search_Field` ( 	`Name` varchar(255) NOT NULL, 	`Weight` decimal(5,2) unsigned NOT NULL, 	`Type` tinyint(4) NOT NULL DEFAULT 0, 	`IsIndexed` tinyint(4) NOT NULL DEFAULT 1, 	`IsSearchable` tinyint(4) NOT NULL DEFAULT 1, 	`IsTokenized` tinyint(4) NOT NULL DEFAULT 1, 	`IsSortable` tinyint(4) NOT NULL DEFAULT 0, 	`IsStored` tinyint(4) NOT NULL DEFAULT 0, 	`IsRetrievable` tinyint(4) NOT NULL DEFAULT 0, 	`Query` text, 	`QueryScope` enum('document','content') default 'document', 	`QueryUseFirstMatched` tinyint(4) NOT NULL, 	`FilterContent` text, 	`RemoveFromParent` tinyint(4) default NULL, 	PRIMARY KEY	 (`Name`) ) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `Search_Field` (`Name`, `Weight`, `IsTokenized`, `IsSearchable`, `IsSortable`, `Query`, `QueryScope`, `QueryUseFirstMatched`, `FilterContent`, `RemoveFromParent`) VALUES ('title', '3.00', 1, 1, 0, 'title', 'document', 0, NULL, 0), ('content', '1.00', 1, 1, 0, '#<!--\\s*content\\s*-->(.+?)<!--\\s*/content\\s*-->#si\r\nbody', 'document', 1, '#<!--\\s*noindex\\s*-->(.+?)<!--\\s*/noindex\\s*-->#si\nscript\nstyle', 0), ('meta', '2.00', 1, 1, 0, '//meta[@name="keywords"]/@content\r\n//meta[@name="description"]/@content', 'document', 0, NULL, 0), ('w2', '2.00', 1, 1, 0, 'h1 h2 h3', 'content', 0, NULL, 1), ('w1_5', '1.50', 1, 1, 0, 'b strong', 'content', 0, NULL, 1);
CREATE TABLE `Search_Document` ( 	`Document_ID` int(11) NOT NULL auto_increment, 	`Catalogue_ID` int(11) NOT NULL, 	`Subdivision_ID` int(11), 	`Ancestors` text, 	`Path` text NOT NULL, 	`Title` text NOT NULL, 	`AncestorTitles` text, 	`Content` mediumtext, 	`Meta` mediumtext, 	`ContentType` varchar(255) NOT NULL, 	`Language` varchar(255) NOT NULL, 	`IncludeInSitemap` tinyint(4) NOT NULL DEFAULT 0, 	`SitemapChangefreq` enum('','always','hourly','daily','weekly','monthly','yearly','never'), 	`SitemapPriority` decimal(2,1) unsigned, 	`Hash` char(40) default NULL, 	`ToDelete` tinyint(4) NOT NULL default '0', 	`LastModified` timestamp NULL, 	`LastUpdated` timestamp NOT NULL default CURRENT_TIMESTAMP, 	PRIMARY KEY	 (`Document_ID`), 	KEY `Sitemap` (`Catalogue_ID`,`IncludeInSitemap`), 	KEY `Title` (`Title` (256)) ) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `Search_Task` ( 	`Task_ID` int(11) unsigned NOT NULL auto_increment, 	`Links` mediumblob NOT NULL, 	`Area` mediumblob NOT NULL, 	`Disallowed` mediumblob, 	`Rule_ID` int(11) NULL, 	`StartTime` int(11) default NULL, 	`TotalProcessed` int(11) default 0, 	`TotalChecked` int(11) default 0, 	`TotalNotFound` int(11) default 0, 	`TotalDeleted` int(11) default 0, 	`Token` int(11) NOT NULL, 	`LastActivity` int(11) default NULL, 	PRIMARY KEY	 (`Task_ID`) ) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `Search_Stopword` ( 	`Word_ID` int(11) NOT NULL auto_increment, 	`Language` varchar(10) NOT NULL, 	`Word` varchar(255) NOT NULL, 	PRIMARY KEY	 (`Word_ID`) ) ENGINE=MyISAM	 DEFAULT CHARSET=utf8;
INSERT INTO `Search_Stopword` (`Language`, `Word`) VALUES ('ru', 'А'), ('ru', 'БЕЗ'), ('ru', 'БОЛЕЕ'), ('ru', 'БЫ'), ('ru', 'БЫТЬ'), ('ru', 'В'), ('ru', 'ВЕСИТЬ'), ('ru', 'ВЕСЬ'), ('ru', 'ВОТ'), ('ru', 'ВСЕ'), ('ru', 'ВЫ'), ('ru', 'ГДЕ'), ('ru', 'ДА'), ('ru', 'ДАЖЕ'), ('ru', 'ДЛИТЬ'), ('ru', 'ДЛЯ'), ('ru', 'ДО'), ('ru', 'ЕСЛИ'), ('ru', 'ЕЩЕ'), ('ru', 'ЖЕ'), ('ru', 'ЗА'), ('ru', 'ЗДЕСЬ'), ('ru', 'И'), ('ru', 'ИЗ'), ('ru', 'ИЛИ'), ('ru', 'К'), ('ru', 'КАК'), ('ru', 'КО'), ('ru', 'КОГДА'), ('ru', 'КТО'), ('ru', 'ЛИ'), ('ru', 'ЛИБО'), ('ru', 'МНОГО'), ('ru', 'МОЖЕТ'), ('ru', 'МОЧЬ'), ('ru', 'МЫ'), ('ru', 'НА'), ('ru', 'НАДО'), ('ru', 'НЕ'), ('ru', 'НЕТ'), ('ru', 'НИ'), ('ru', 'НО'), ('ru', 'НУ'), ('ru', 'О'), ('ru', 'ОБ'), ('ru', 'ОДНАКО'), ('ru', 'ОН'), ('ru', 'ОНА'), ('ru', 'ОНИ'), ('ru', 'ОНО'), ('ru', 'ОТ'), ('ru', 'ОЧЕНЬ'), ('ru', 'ПЕРЕТЬ'), ('ru', 'ПО'), ('ru', 'ПОД'), ('ru', 'ПРИ'), ('ru', 'ПРЯ'), ('ru', 'С'), ('ru', 'СО'), ('ru', 'ТАК'), ('ru', 'ТАКОЙ'), ('ru', 'ТАМ'), ('ru', 'ТО'), ('ru', 'ТОГО'), ('ru', 'ТОЖЕ'), ('ru', 'ТОЛЬКО'), ('ru', 'ТОТ'), ('ru', 'ТЫ'), ('ru', 'У'), ('ru', 'УЖ'), ('ru', 'УЖЕ'), ('ru', 'УЗКИЙ'), ('ru', 'ХОТЕТЬ'), ('ru', 'ХОТЯ'), ('ru', 'ЧЕГО'), ('ru', 'ЧЕЙ'), ('ru', 'ЧЕМ'), ('ru', 'ЧТО'), ('ru', 'ЧТОБЫ'), ('ru', 'ЭТО'), ('ru', 'ЭТОТ'), ('ru', 'Я'), ('en', 'A'), ('en', 'ABLE'), ('en', 'ABOUT'), ('en', 'ABOVE'), ('en', 'ACCORD'), ('en', 'ACCORDING'), ('en', 'ACCORDINGLY'), ('en', 'ACROSS'), ('en', 'ACTUALLY'), ('en', 'AFTER'), ('en', 'AFTERWARDS'), ('en', 'AGAIN'), ('en', 'AGAINST'), ('en', 'ALL'), ('en', 'ALLOW'), ('en', 'ALMOST'), ('en', 'ALONE'), ('en', 'ALONG'), ('en', 'ALREADY'), ('en', 'ALSO'), ('en', 'ALTHOUGH'), ('en', 'ALWAYS'), ('en', 'AMONG'), ('en', 'AMONGST'), ('en', 'AN'), ('en', 'AND'), ('en', 'ANOTHER'), ('en', 'ANY'), ('en', 'ANYBODY'), ('en', 'ANYHOW'), ('en', 'ANYONE'), ('en', 'ANYTHING'), ('en', 'ANYWAY'), ('en', 'ANYWAYS'), ('en', 'ANYWHERE'), ('en', 'APART'), ('en', 'APPEAR'), ('en', 'APPRECIATE'), ('en', 'APPROPRIATE'), ('en', 'AROUND'), ('en', 'AS'), ('en', 'ASIDE'), ('en', 'ASK'), ('en', 'ASKING'), ('en', 'ASSOCIATE'), ('en', 'ASSOCIATED'), ('en', 'AT'), ('en', 'AVAILABLE'), ('en', 'AWAY'), ('en', 'AWFULLY'), ('en', 'BE'), ('en', 'BECAUSE'), ('en', 'BECOME'), ('en', 'BEFORE'), ('en', 'BEFOREHAND'), ('en', 'BEHIND'), ('en', 'BELIEVE'), ('en', 'BELOW'), ('en', 'BESIDE'), ('en', 'BESIDES'), ('en', 'BEST'), ('en', 'BETTER'), ('en', 'BETWEEN'), ('en', 'BEYOND'), ('en', 'BOTH'), ('en', 'BRIEF'), ('en', 'BUT'), ('en', 'BY'), ('en', 'CAN'), ('en', 'CANNOT'), ('en', 'CANT'), ('en', 'CAUSE'), ('en', 'CERTAIN'), ('en', 'CERTAINLY'), ('en', 'CHANGE'), ('en', 'CLEARLY'), ('en', 'CO'), ('en', 'COME'), ('en', 'CONCERN'), ('en', 'CONCERNING'), ('en', 'CONSEQUENTLY'), ('en', 'CONSIDER'), ('en', 'CONSIDERING'), ('en', 'CONTAIN'), ('en', 'CORRESPOND'), ('en', 'CORRESPONDING'), ('en', 'COURSE'), ('en', 'CURRENTLY'), ('en', 'DEFINITELY'), ('en', 'DESCRIBE'), ('en', 'DESPITE'), ('en', 'DIFFERENT'), ('en', 'DO'), ('en', 'DOE'), ('en', 'DOING'), ('en', 'DOWN'), ('en', 'DOWNWARDS'), ('en', 'DURING'), ('en', 'EACH'), ('en', 'EG'), ('en', 'EITHER'), ('en', 'ELSE'), ('en', 'ELSEWHERE'), ('en', 'ENOUGH'), ('en', 'ENTIRELY'), ('en', 'ESPECIALLY'), ('en', 'ET'), ('en', 'EVEN'), ('en', 'EVER'), ('en', 'EVERY'), ('en', 'EVERYBODY'), ('en', 'EVERYONE'), ('en', 'EVERYTHING'), ('en', 'EVERYWHERE'), ('en', 'EXACTLY'), ('en', 'EXCEPT'), ('en', 'FAR'), ('en', 'FEW'), ('en', 'FOLLOW'), ('en', 'FOR'), ('en', 'FORMER'), ('en', 'FORMERLY'), ('en', 'FROM'), ('en', 'FURTHER'), ('en', 'FURTHERMORE'), ('en', 'GET'), ('en', 'GETTING'), ('en', 'GIVE'), ('en', 'GIVEN'), ('en', 'GO'), ('en', 'GOING'), ('en', 'GONE'), ('en', 'GOOD'), ('en', 'GOTTEN'), ('en', 'GREETING'), ('en', 'HA'), ('en', 'HAPPEN'), ('en', 'HARDLY'), ('en', 'HAVE'), ('en', 'HAVING'), ('en', 'HE'), ('en', 'HELLO'), ('en', 'HENCE'), ('en', 'HER'), ('en', 'HERE'), ('en', 'HEREAFTER'), ('en', 'HEREBY'), ('en', 'HEREIN'), ('en', 'HEREUPON'), ('en', 'HERSELF'), ('en', 'HI'), ('en', 'HIMSELF'), ('en', 'HIS'), ('en', 'HITHER'), ('en', 'HOPEFULLY'), ('en', 'HOW'), ('en', 'HOWBEIT'), ('en', 'HOWEVER'), ('en', 'I'), ('en', 'IF'), ('en', 'IGNORE'), ('en', 'IMMEDIATE'), ('en', 'IN'), ('en', 'INASMUCH'), ('en', 'INDEED'), ('en', 'INDICATE'), ('en', 'INNER'), ('en', 'INSOFAR'), ('en', 'INSTEAD'), ('en', 'INTO'), ('en', 'INWARD'), ('en', 'IT'), ('en', 'ITS'), ('en', 'ITSELF'), ('en', 'JUST'), ('en', 'KEEP'), ('en', 'KEPT'), ('en', 'KNOW'), ('en', 'KNOWN'), ('en', 'LAST'), ('en', 'LATE'), ('en', 'LATELY'), ('en', 'LATER'), ('en', 'LATTER'), ('en', 'LEAST'), ('en', 'LESS'), ('en', 'LEST'), ('en', 'LET'), ('en', 'LIKE'), ('en', 'LIKELY'), ('en', 'LITTLE'), ('en', 'LL'), ('en', 'LOOK'), ('en', 'LOOKING'), ('en', 'LTD'), ('en', 'MAINLY'), ('en', 'MANY'), ('en', 'MAY'), ('en', 'MAYBE'), ('en', 'MEAN'), ('en', 'MEANWHILE'), ('en', 'MERELY'), ('en', 'MORE'), ('en', 'MOREOVER'), ('en', 'MOST'), ('en', 'MOSTLY'), ('en', 'MUCH'), ('en', 'MUST'), ('en', 'MY'), ('en', 'MYSELF'), ('en', 'NAME'), ('en', 'NAMELY'), ('en', 'ND'), ('en', 'NEAR'), ('en', 'NEARLY'), ('en', 'NECESSARY'), ('en', 'NEED'), ('en', 'NEITHER'), ('en', 'NEVER'), ('en', 'NEVERTHELESS'), ('en', 'NEW'), ('en', 'NEXT'), ('en', 'NO'), ('en', 'NOBODY'), ('en', 'NON'), ('en', 'NONE'), ('en', 'NOONE'), ('en', 'NOR'), ('en', 'NORMALLY'), ('en', 'NOT'), ('en', 'NOTHING'), ('en', 'NOW'), ('en', 'NOWHERE'), ('en', 'O'), ('en', 'OBVIOUSLY'), ('en', 'OF'), ('en', 'OFF'), ('en', 'OFTEN'), ('en', 'OH'), ('en', 'OK'), ('en', 'OKAY'), ('en', 'OLD'), ('en', 'ON'), ('en', 'ONCE'), ('en', 'ONE'), ('en', 'ONLY'), ('en', 'ONTO'), ('en', 'OR'), ('en', 'OTHER'), ('en', 'OTHERWISE'), ('en', 'OUGHT'), ('en', 'OUR'), ('en', 'OURSELF'), ('en', 'OUT'), ('en', 'OUTSIDE'), ('en', 'OVER'), ('en', 'OVERALL'), ('en', 'OWN'), ('en', 'PARTICULAR'), ('en', 'PARTICULARLY'), ('en', 'PER'), ('en', 'PERHAPS'), ('en', 'PLACE'), ('en', 'PLACED'), ('en', 'PLEASE'), ('en', 'PLUS'), ('en', 'POSSIBLE'), ('en', 'PRESUMABLY'), ('en', 'PROBABLY'), ('en', 'PROVIDE'), ('en', 'QUITE'), ('en', 'RATHE'), ('en', 'RATHER'), ('en', 'RD'), ('en', 'RE'), ('en', 'REALLY'), ('en', 'REASONABLY'), ('en', 'REGARD'), ('en', 'REGARDING'), ('en', 'REGARDLESS'), ('en', 'RELATIVELY'), ('en', 'RESPECTIVELY'), ('en', 'RIGHT'), ('en', 'SAME'), ('en', 'SAW'), ('en', 'SAY'), ('en', 'SAYING'), ('en', 'SEE'), ('en', 'SEEING'), ('en', 'SEEM'), ('en', 'SEEMING'), ('en', 'SELF'), ('en', 'SENSIBLE'), ('en', 'SERIOUS'), ('en', 'SERIOUSLY'), ('en', 'SEVERAL'), ('en', 'SHALL'), ('en', 'SHE'), ('en', 'SINCE'), ('en', 'SO'), ('en', 'SOME'), ('en', 'SOMEBODY'), ('en', 'SOMEHOW'), ('en', 'SOMEONE'), ('en', 'SOMETHING'), ('en', 'SOMETIME'), ('en', 'SOMETIMES'), ('en', 'SOMEWHAT'), ('en', 'SOMEWHERE'), ('en', 'SOON'), ('en', 'SORRY'), ('en', 'SPECIFY'), ('en', 'STILL'), ('en', 'SUCH'), ('en', 'SURE'), ('en', 'TAKE'), ('en', 'TELL'), ('en', 'TEND'), ('en', 'THAN'), ('en', 'THANK'), ('en', 'THANX'), ('en', 'THAT'), ('en', 'THE'), ('en', 'THEIR'), ('en', 'THEMSELVES'), ('en', 'THEN'), ('en', 'THENCE'), ('en', 'THERE'), ('en', 'THEREAFTER'), ('en', 'THEREBY'), ('en', 'THEREFORE'), ('en', 'THEREIN'), ('en', 'THERES'), ('en', 'THEREUPON'), ('en', 'THEY'), ('en', 'THINK'), ('en', 'THIS'), ('en', 'THOROUGH'), ('en', 'THOROUGHLY'), ('en', 'THOUGH'), ('en', 'THROUGH'), ('en', 'THROUGHOUT'), ('en', 'THRU'), ('en', 'THUS'), ('en', 'TO'), ('en', 'TOGETHER'), ('en', 'TOO'), ('en', 'TOWARD'), ('en', 'TOWARDS'), ('en', 'TRULY'), ('en', 'TRY'), ('en', 'TRYING'), ('en', 'U'), ('en', 'UN'), ('en', 'UNDER'), ('en', 'UNFORTUNATELY'), ('en', 'UNLESS'), ('en', 'UNLIKELY'), ('en', 'UNTIL'), ('en', 'UNTO'), ('en', 'UP'), ('en', 'UPON'), ('en', 'USE'), ('en', 'USED'), ('en', 'USEFUL'), ('en', 'USUALLY'), ('en', 'V'), ('en', 'VALUE'), ('en', 'VARIOUS'), ('en', 'VERY'), ('en', 'VIA'), ('en', 'VIZ'), ('en', 'WANT'), ('en', 'WAY'), ('en', 'WE'), ('en', 'WELL'), ('en', 'WHAT'), ('en', 'WHATEVER'), ('en', 'WHEN'), ('en', 'WHENCE'), ('en', 'WHENEVER'), ('en', 'WHERE'), ('en', 'WHEREAFTER'), ('en', 'WHEREAS'), ('en', 'WHEREBY'), ('en', 'WHEREIN'), ('en', 'WHEREUPON'), ('en', 'WHEREVER'), ('en', 'WHETHER'), ('en', 'WHICH'), ('en', 'WHILE'), ('en', 'WHITHER'), ('en', 'WHO'), ('en', 'WHOEVER'), ('en', 'WHOLE'), ('en', 'WHOSE'), ('en', 'WHY'), ('en', 'WILL'), ('en', 'WILLING'), ('en', 'WISH'), ('en', 'WITH'), ('en', 'WITHIN'), ('en', 'WITHOUT'), ('en', 'WOULD'), ('en', 'YES'), ('en', 'YET'), ('en', 'YOU'), ('en', 'YOUR'), ('en', 'YOURSELF');
CREATE TABLE `Search_Synonym` ( 	`Synonyms_ID` int(11) NOT NULL auto_increment, 	`Language` varchar(10) NOT NULL, 	`Words` text NOT NULL, 	PRIMARY KEY	 (`Synonyms_ID`) ) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `Search_Synonym` (`Synonyms_ID`, `Language`, `Words`) VALUES(1, 'ru', 'a:2:{i:0;s:6:"NETCAT";i:1;s:14:"НЕТКЭТА";}');
CREATE TABLE `Search_Rule` ( 	`Rule_ID` int(11) NOT NULL auto_increment, 	`Name` varchar(255) NOT NULL, 	`Catalogue_ID` int(11) NULL, 	`AreaString` text, 	`Interval` smallint(6) NULL, 	`IntervalType` varchar(255) NOT NULL, 	`Hour` tinyint(4) NULL, 	`Minute` tinyint(4) NULL, 	`LastStartTime` int(11) NULL, 	`LastFinishTime` int(11) NULL, 	`LastResult` blob NOT NULL, 	PRIMARY KEY	 (`Rule_ID`) ) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `Search_Log` ( `Log_ID` INT NOT NULL auto_increment, `Timestamp` TIMESTAMP NOT NULL , `Type` VARCHAR(255) NOT NULL, `Message` MEDIUMTEXT NOT NULL, PRIMARY KEY	 (`Log_ID`) ) ENGINE = MYISAM DEFAULT CHARSET=utf8;
CREATE TABLE `Search_Schedule` ( `Schedule_ID` INT NOT NULL auto_increment , `Type` TINYINT NOT NULL, `AreaString` TEXT NOT NULL , `StartTime` INT NOT NULL, PRIMARY KEY	 (`Schedule_ID`) ) ENGINE = MYISAM DEFAULT CHARSET=utf8;
CREATE TABLE `Search_Query` ( 	`Query_ID` int(11) NOT NULL auto_increment, 	`Timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP, 	`QueryString` varchar(255) NOT NULL, 	`Area` text NULL, 	`Catalogue_ID` int(11) NULL, 	`Language` varchar(255), 	`ResultsCount` int(11) NOT NULL, 	`IP` int(11) NULL, 	`User_ID` int(11) NULL, 	PRIMARY KEY	 (`Query_ID`), 	KEY `QueryString` (`QueryString`) ) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `Search_Link` ( 	`Link_ID` int(11) NOT NULL auto_increment, 	`URL` text NOT NULL, 	`Processed` tinyint(4) NOT NULL, 	`Broken` tinyint(4) NOT NULL, 	PRIMARY KEY	 (`Link_ID`) ) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `Search_LinkReferrer` ( 	`Source_Document_ID` int(11) NULL, 	`Source_Link_ID` int(11) NOT NULL, 	`Target_Link_ID` int(11) NOT NULL ) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `Search_BrokenLink` ( 	`URL` text NOT NULL, 	`Referrer_URL` text NOT NULL, 	`Referrer_Document_ID` int(11) NULL, 	`ToDelete` tinyint(4) DEFAULT 0, 	KEY `URL` (`URL` (100)), 	KEY `Referrer_URL` (`Referrer_URL` (100)) ) ENGINE=MyISAM DEFAULT CHARSET=utf8;
